#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include "csik.h"

char buf[17000];
char zeros[17000];
char aa[200];

int skip;
FILE *boolf;
int reffd;
int newfd;
int blsz;
int i;
char dummy;
long long int length;
long long int sofar=0;
int rb;
int end=0;

int main (int argc, char *argv[])
{
	if (argc != 7) {
		fprintf(stderr, "Usage: update_file blocksize boolfile reffile newfile info length\n"
		                "boolfile can be '-' meaning stdin\n");
		exit(1);
	}
	if (argv[2][0]=='-' && argv[2][1]==0)
		boolf=stdin;
	else {
		boolf=fopen(argv[2], "r");
		if (boolf==NULL) {
			fprintf(stderr, "Cannot open file: %s\n", sys_errlist[errno]);
			exit(1);
		}
	}
	i=sscanf(argv[1], "%d%c", &blsz, &dummy);
	if (i!=1 || (blsz!=1024 && blsz!=2048 && blsz!=4096 && blsz!=8192 && blsz!=16384)) {
		fprintf(stderr, "Invalid block size. Valid sizes: 1024, 2048, 4096, 8192, 16384.\n");
		exit(1);
	}
	reffd=open(argv[3], O_RDONLY);
	if (reffd==-1) {
		fprintf(stderr, "Opening %s failed: %s\n", argv[3], sys_errlist[errno]);
		exit(1);
	}
	newfd=open(argv[4], O_WRONLY);
	if (newfd==-1) {
		fprintf(stderr, "Opening %s failed: %s\n", argv[4], sys_errlist[errno]);
		exit(1);
	}
	i=sscanf(argv[6], "%lld%c", &length, &dummy);
	if (i!=1) {
		fprintf(stderr, "Invalid length.\n");
		exit(1);
	}

	csik(0, length, argv[5]);
	for (i=0; i<blsz; i++) zeros[i]=0;

	skip=0;
	while (1) {
		if (fgets(aa, 180, boolf)==NULL) break;
		if (end) {
			fprintf(stderr, "Could not read %d bytes\n", blsz);
			exit(1);
		}
		if ((aa[0]!='0' && aa[0]!='1' && aa[0]!='z') || aa[1]!='\n') {
			fprintf(stderr, "Invalid data in bool file\n");
			exit(1);
		}
		if (aa[0]=='0') {
			skip++;
			continue;
		}
		if (lseek(reffd, (skip+(aa[0]=='z'))*blsz, SEEK_CUR)==-1) {
			fprintf(stderr, "lseek %s failed: %s\n", argv[3], sys_errlist[errno]);
			exit(1);
		}
		if (lseek(newfd, skip*blsz, SEEK_CUR)==-1) {
			fprintf(stderr, "lseek %s failed: %s\n", argv[4], sys_errlist[errno]);
			exit(1);
		}
		for (i=0; i<blsz; i++) buf[i]=0;
		rb=blsz;
		if (aa[0]=='1' && (rb=read(reffd, buf, blsz))==-1) {
			fprintf(stderr, "read failed: %s\n", sys_errlist[errno]);
			exit(1);
		}
		if (rb!=blsz) end=1;
		if (write(newfd, aa[0]=='1' ? buf : zeros, rb)==-1) {
			fprintf(stderr, "write failed: %s\n", sys_errlist[errno]);
			exit(1);
		}
		if (aa[0]=='1') {
			sofar++;
			csik(sofar, length, argv[5]);
		}
		skip=0;
	}
	return 0;
}
